#define _CRT_SECURE_NO_WARNINGS
#define bool unsigned int
#define true 1
#define false 0

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char text[10000][256];
unsigned char ch1[65536];
unsigned char ch2[65536];

int hex2int(char c)
{
    if(c=='.') return 0;
    if(c>='0'&&c<='9') return c-'0';
    if(c>='A'&&c<='F') return c-'A'+10;
    return -1;
}



int frameconv(int f)
{
    return f;//((long)f*3500000/506/138/50);
}



int readnote(char *line)
{
    int note;
    
    switch(line[0])
    {
        case 'C': note=0; break;
        case 'D': note=2; break;
        case 'E': note=4; break;
        case 'F': note=5; break;
        case 'G': note=7; break;
        case 'A': note=9; break;
        case 'B': note=11; break;
        case 'R': return 184;
    }
    
    if(line[1]=='#') note++;
    
    note=note+(line[2]-'0'-1)*12;
    
    if(note>=60) return 59;

    if(line[5]!='.') note+=60;

    return 64+note;
}



int readparam(char *line)
{
    return hex2int(line[2])+hex2int(line[1])*16+hex2int(line[0])*256;
}



int main(int argc, char *argv[])
{
    FILE *file;
    char *data,c,cc;
    int i,j,size,pp,row;
    int icnt,cnt;
    int t,note;
    unsigned char env[64];
    int spd,loop,ordlen;
    int ord[256];
    bool setloop;
    int ptr1,ptr2;
    char ptname[32];
    int instr1,instr2,drum;
    char name[1024];

    if(argc<2)
    {
        printf("VT2 module to Stocker engine converter v1.0\n");
        printf("by Shiru (shiru@mail.ru) 08'10\n");
        printf("Usage: vt2txconv.exe module.txt [file.asm]\n");
        return 0;
    }

    file=fopen(argv[1],"rb");
    if(!file) return 1;

    fseek(file,0,SEEK_END);
    size=ftell(file);
    fseek(file,0,SEEK_SET);
    data=(char*)malloc(size);
    fread(data,size,1,file);
    fclose(file);
    
    if(argc>2)
    {
        strcpy(name,argv[2]);
    }
    else
    {
        strcpy(name,argv[1]);
        name[strlen(name)-3]='a';
        name[strlen(name)-2]='s';
        name[strlen(name)-1]='m';
    }

    file=fopen(name,"wt");

//pointers

    strcpy(name,argv[1]);
    for(i=strlen(name)-1;i>=0;i--)
    {
        if(name[i]=='.')
        {
            name[i]=0;
            break;
        }
    }
    for(i=strlen(name)-1;i>=0;i--)
    {
        if(name[i]=='\\'||name[i]=='/')
        {
            strcpy(name,&name[i+1]);
            break;
        }
    }

    fprintf(file,"%s\n",name);
    fprintf(file,"\tdw .inslist,.ch1,.ch2\n\n");

//convert text to array

    pp=0;
    row=0;
    i=0;
    
    while(pp<size)
    {
        c=data[pp++];
        if(c==0x0d||pp==(size-1))
        {
            text[row][i]=0;
            row++;
            pp++;
            i=0;
            continue;
        }
        if(i<255) text[row][i++]=c;
    }

//get author and song name

    for(i=0;i<row;i++)
    {
        if(!memcmp(text[i],"Title=",6))
        {
            fprintf(file,".title\n\tdb ");
            if(strlen(text[i])>6)
            {
                fprintf(file,"\"");
                for(j=6;j<(int)strlen(text[i]);j++) fprintf(file,"%c",text[i][j]);
                fprintf(file,"\",0\n\n");
            }
            else
            {
                fprintf(file,"0\n\n");
            }
            break;
        }
    }
    
    for(i=0;i<row;i++)
    {
        if(!memcmp(text[i],"Author=",7))
        {
            fprintf(file,".author\n\tdb ");
            if(strlen(text[i])>7)
            {
                fprintf(file,"\"");
                for(j=7;j<(int)strlen(text[i]);j++) fprintf(file,"%c",text[i][j]);
                fprintf(file,"\",0\n\n");
            }
            else
            {
                fprintf(file,"0\n\n");
            }
            break;
        }
    }

//convert instruments

    icnt=0;

    for(i=0;i<row;i++)
    {
        if(!memcmp(text[i],"[Sample",7))
        {
            pp=i+1;

            if(atoi(text[i]+7)<17&&text[pp][0]=='T')
            {
                icnt++;
                fprintf(file,".ins%i\n",icnt);
                
                cnt=0;

                while(pp<row)
                {
                    if(!text[pp][0]) break;
                    c=text[pp][15];
                    if(c>='A') c=c-'A'+10; else c=c-'0';
                    env[cnt++]=c*2;
                    pp++;
                }

                fprintf(file,"\tdb ");

                j=0;
                t=0;
                cc=env[0];
                
                while(j<cnt)
                {
                    c=env[j++];
                    if(c!=cc||j==cnt)
                    {
                        fprintf(file,"%i,%i,",cc,frameconv(t));
                        cc=c;
                        if(j==cnt)
                        {
                            fprintf(file,"%i,%i",c,255);
                            if(j<cnt) fprintf(file,","); else fprintf(file,"\n");
                        }
                        t=1;
                    }
                    else
                    {
                        t++;
                    }
                }
            }
            
            i=pp;
        }
    }

//make instrument list

    fprintf(file,"\n");
    fprintf(file,".inslist\n\tdw ");

    for(i=0;i<icnt;i++)
    {
        fprintf(file,".ins%i",i+1);
        if(i<icnt-1) fprintf(file,","); else fprintf(file,"\n");
    }
    
//read default speed

    for(i=0;i<row;i++)
    {
        if(!memcmp(text[i],"Speed=",6))
        {
            spd=frameconv(atoi(text[i]+6));
            break;
        }
    }
    
//parse order list

    loop=0;
    ordlen=0;
    setloop=false;
    
    for(i=0;i<row;i++)
    {
        if(!memcmp(text[i],"PlayOrder=",10))
        {
            pp=10;
            
            while(pp<(int)strlen(text[i]))
            {
                if(text[i][pp]=='L')
                {
                    setloop=true;
                    pp++;
                }
                ord[ordlen++]=atoi(text[i]+pp);
                if(setloop)
                {
                    loop=ordlen-1;
                    setloop=false;
                }
                while(text[i][pp]!=','&&text[i][pp]!=0) pp++;
                pp++;
            }
        }
    }
    
//convert patterns

    ptr1=0;
    ptr2=0;
    instr1=-1;
    instr2=-1;
    drum=-1;
    
    ch1[ptr1++]=253;
    ch1[ptr1++]=spd;
    ch1[ptr1++]=192;
    ch1[ptr1++]=184;
    ch2[ptr2++]=192;
    ch2[ptr2++]=184;

    for(i=0;i<ordlen;i++)
    {
        if(i==loop)
        {
            ch1[ptr1++]=254;
            ch2[ptr2++]=254;
        }
        
        sprintf(ptname,"[Pattern%i]",ord[i]);
        
        pp=0;

        for(j=0;j<row;j++)
        {
            if(!memcmp(text[j],ptname,strlen(ptname)))
            {
                pp=j+1;
                break;
            }
        }
        
        if(!pp)
        {
            printf("Parsing error\n");
            return 1;
        }

        while(pp<row)
        {
            if(!text[pp][0]) break;

            if(text[pp][17]=='B')//speed change
            {
                ch1[ptr1++]=253;
                ch1[ptr1++]=frameconv(hex2int(text[pp][20]));
            }

            if(text[pp][40]!='.')//drums
            {
                if(text[pp][40]>='H'&&text[pp][40]<='K')
                {
                    drum=text[pp][40]-'H'+224;
                }
            }
            if(text[pp][36]!='-')
            {
                if(drum>=0) ch1[ptr1++]=drum;
            }

            if(text[pp][12]!='.')//ch1 instrument
            {
                icnt=hex2int(text[pp][12]);
                if(icnt>=0)
                {
                    if(icnt!=instr1)
                    {
                        ch1[ptr1++]=192+icnt-1;
                        instr1=icnt;
                    }
                }
            }

            switch(text[pp][17])//slides, detune
            {
                case '1'://down
                    ch1[ptr1++]=252;
                    t=-readparam(text[pp]+18);
                    ch1[ptr1++]=t&255;
                    ch1[ptr1++]=t>>8;
                    break;
                case '2'://up
                    ch1[ptr1++]=252;
                    t=readparam(text[pp]+18);
                    ch1[ptr1++]=t&255;
                    ch1[ptr1++]=t>>8;
                    break;
                case '3'://detune
                    ch1[ptr1++]=251;
                    ch1[ptr1++]=readparam(text[pp]+18);
                    break;
            }

            if(text[pp][8]!='-')//ch1 note
            {
                note=readnote(text[pp]+8);
                if(note>0) ch1[ptr1++]=note;
            }
            else
            {
                ch1[ptr1++]=0;
            }

            if(text[pp][26]!='.')//ch2 instrument
            {
                icnt=hex2int(text[pp][26]);
                if(icnt>=0)
                {
                    if(icnt!=instr2)
                    {
                        ch2[ptr2++]=192+icnt-1;
                        instr2=icnt;
                    }
                }
            }

            switch(text[pp][31])//slides, detune
            {
                case '1'://down
                    ch1[ptr2++]=252;
                    t=-readparam(text[pp]+32);
                    ch1[ptr2++]=t&255;
                    ch1[ptr2++]=t>>8;
                    break;
                case '2'://up
                    ch1[ptr2++]=252;
                    t=readparam(text[pp]+32);
                    ch1[ptr2++]=t&255;
                    ch1[ptr2++]=t>>8;
                    break;
                case '3'://detune
                    ch1[ptr2++]=251;
                    ch1[ptr2++]=readparam(text[pp]+32);
                    break;
            }

            if(text[pp][22]!='-')//ch2 note
            {
                note=readnote(text[pp]+22);
                if(note>0) ch2[ptr2++]=note;
            }
            else
            {
                ch2[ptr2++]=0;
            }

            pp++;
        }
    }

    ch1[ptr1++]=255;
    ch2[ptr2++]=255;

//replace short pauses

    pp=0;
    
    while(pp<ptr1)
    {
        t=ch1[pp];
        if(t<63)
        {
            if(ch1[pp+1]==0)
            {
                ch1[pp]++;
                memcpy(&ch1[pp+1],&ch1[pp+2],65536-(pp+2));
                ptr1--;
                continue;
            }
        }
        else
        {
            if(t==251) pp++;
            if(t==252) pp+=2;
            if(t==253) pp++;
        }
        pp++;
    }

    pp=0;

    while(pp<ptr2)
    {
        t=ch2[pp];
        if(t<63)
        {
            if(ch2[pp+1]==0)
            {
                ch2[pp]++;
                memcpy(&ch2[pp+1],&ch2[pp+2],65536-(pp+2));
                ptr2--;
                continue;
            }
        }
        else
        {
            if(t==251) pp++;
            if(t==252) pp+=2;
            if(t==253) pp++;
        }
        pp++;
    }

//data to assembly text

    fprintf(file,"\n");
    fprintf(file,".ch1\n\tdb ");

    for(i=0;i<ptr1;i++)
    {
        fprintf(file,"%i",ch1[i]);
        if(i<ptr1-1)
        {
            if((i&15)==15) fprintf(file,"\n\tdb "); else fprintf(file,",");
        }
        else
        {
            fprintf(file,"\n");
        }
    }
    
    fprintf(file,"\n");
    fprintf(file,".ch2\n\tdb ");

    for(i=0;i<ptr2;i++)
    {
        fprintf(file,"%i",ch2[i]);
        if(i<ptr2-1)
        {
            if((i&15)==15) fprintf(file,"\n\tdb "); else fprintf(file,",");
        }
        else
        {
            fprintf(file,"\n");
        }
    }

    fclose(file);

    return 0;
}
